diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
index f4d6fda8c..7d3ab1f45 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
@@ -570,49 +595,51 @@ public class EntityMinecart extends Entity implements Container {
         double vecX = x + d4 * scalar;
         double vecZ = z + d5 * scalar;
         double vecY = blockY;
-        if(ai[0][1] != 0 && MathHelper.floor(x) - blockX == ai[0][0] && MathHelper.floor(z) - blockZ == ai[0][2]) {
+        if (ai[0][1] != 0 && MathHelper.floor(x) - blockX == ai[0][0] && MathHelper.floor(z) - blockZ == ai[0][2]) {
             vecY += ai[0][1];
-        } else if(ai[1][1] != 0 && MathHelper.floor(x) - blockX == ai[1][0] && MathHelper.floor(z) - blockZ == ai[1][2]) {
+        } else if (ai[1][1] != 0 && MathHelper.floor(x) - blockX == ai[1][0] && MathHelper.floor(z) - blockZ == ai[1][2]) {
             vecY += ai[1][1];
         }
         return getPos(vecX, vecY, vecZ);
     }
+
     /**
      * @return null if not on rail otherwise ?
      */
     // If this gets fucked up then the animation looks wrong?
-    @Nullable
-    public Vec3 getPos(final double x, final double y, final double z) {
+    public @Nullable Vector3dc getPos(final double x, final double y, final double z) {
         int blockX = MathHelper.floor(x);
         int blockY = MathHelper.floor(y);
         int blockZ = MathHelper.floor(z);
 
-        if(BlockLogicRail.isRailBlockAt(world, new TilePos(blockX, blockY - 1, blockZ))) {
+        if (BlockLogicRail.isRailBlockAt(this.world, new TilePos(blockX, blockY - 1, blockZ))) {
             blockY--;
         }
-        Block<?> block = world.getBlock(blockX, blockY, blockZ);
-        if (!(Block.hasLogicClass(block, BlockLogicRail.class))) { return null; }
+        Block<?> block = this.world.getBlock(blockX, blockY, blockZ);
+        if (!(Block.hasLogicClass(block, BlockLogicRail.class))) {
+            return null;
+        }
 
         BlockLogicRail rail = (BlockLogicRail) block.getLogic();
-        RailDirection direction = rail.getRailDirection(world, new TilePos(blockX, blockY, blockZ));
+        RailDirection direction = rail.getRailDirection(this.world, new TilePos(blockX, blockY, blockZ));
 
         int[][] offsetMap = EXITS[direction.meta];
-        double x1 = (double)blockX + 0.5D + (double)offsetMap[0][0] * 0.5D;
-        double y1 = (double)blockY + 0.5D + (double)offsetMap[0][1] * 0.5D;
-        double z1 = (double)blockZ + 0.5D + (double)offsetMap[0][2] * 0.5D;
-        double x2 = (double)blockX + 0.5D + (double)offsetMap[1][0] * 0.5D;
-        double y2 = (double)blockY + 0.5D + (double)offsetMap[1][1] * 0.5D;
-        double z2 = (double)blockZ + 0.5D + (double)offsetMap[1][2] * 0.5D;
+        double x1 = (double) blockX + 0.5D + (double) offsetMap[0][0] * 0.5D;
+        double y1 = (double) blockY + 0.5D + (double) offsetMap[0][1] * 0.5D;
+        double z1 = (double) blockZ + 0.5D + (double) offsetMap[0][2] * 0.5D;
+        double x2 = (double) blockX + 0.5D + (double) offsetMap[1][0] * 0.5D;
+        double y2 = (double) blockY + 0.5D + (double) offsetMap[1][1] * 0.5D;
+        double z2 = (double) blockZ + 0.5D + (double) offsetMap[1][2] * 0.5D;
 
         double railsDX = x2 - x1;
         double railsDY = (y2 - y1) * 2D;
         double railsDZ = z2 - z1;
 
         double proximity; // ?
-        if(railsDX == 0.0D) { // If rail axis is aligned NorthSouth
-            proximity = z - (double)blockZ;
-        } else if(railsDZ == 0.0D) { // If rail axis is aligned EastWest
-            proximity = x - (double)blockX;
+        if (railsDX == 0.0D) { // If rail axis is aligned NorthSouth
+            proximity = z - (double) blockZ;
+        } else if (railsDZ == 0.0D) { // If rail axis is aligned EastWest
+            proximity = x - (double) blockX;
         } else { // If Rail Curves?
             double targetDX = x - x1;
             double targetDZ = z - z1;
@@ -622,48 +649,48 @@ public class EntityMinecart extends Entity implements Container {
         double vecX = x1 + railsDX * proximity;
         double vecY = y1 + railsDY * proximity;
         double vecZ = z1 + railsDZ * proximity;
-        if(railsDY < 0.0D) {
+        if (railsDY < 0.0D) {
             vecY++;
         }
 
-        if(railsDY > 0.0D) {
+        if (railsDY > 0.0D) {
             vecY += 0.5D;
         }
-        return Vec3.fromPool(vecX, vecY, vecZ);
+        return new Vector3d(vecX, vecY, vecZ);
     }
 
     @Override
     public void lerpTo(double x, double y, double z, float yRot, float xRot, int ticks) {
-        lerpX = x;
-        lerpY = y;
-        lerpZ = z;
-        lerpYRot = yRot;
-        lerpXRot = xRot;
-        lerpTicks = 2;
-        xd = lerpXD;
-        yd = lerpYD;
-        zd = lerpZD;
+        this.lerpX = x;
+        this.lerpY = y;
+        this.lerpZ = z;
+        this.lerpYRot = yRot;
+        this.lerpXRot = xRot;
+        this.lerpTicks = 2;
+        this.xd = this.lerpXD;
+        this.yd = this.lerpYD;
+        this.zd = this.lerpZD;
     }
 
     @Override
     public void lerpMotion(double xd, double yd, double zd) {
-        lerpXD = this.xd = xd;
-        lerpYD = this.yd = yd;
-        lerpZD = this.zd = zd;
+        this.lerpXD = this.xd = xd;
+        this.lerpYD = this.yd = yd;
+        this.lerpZD = this.zd = zd;
     }
 
     @Override
-	public void push(Entity entity) {
-        if(world.isClientSide) {
+    public void push(Entity entity) {
+        if (this.world.isClientSide) {
             return;
         }
-        if(entity == passenger) {
+        if (entity == this.passenger) {
             return;
         }
-        if(!entity.isPushable()) {
-        	return;
+        if (!entity.isPushable()) {
+            return;
         }
-        if(getType() == PASSENGER_CART && (entity instanceof Mob) && !(entity instanceof Player) && xd * xd + zd * zd > 0.01D && passenger == null && entity.vehicle == null) {
+        if (getType() == PASSENGER_CART && (entity instanceof Mob) && !(entity instanceof Player) && this.xd * this.xd + this.zd * this.zd > 0.01D && this.passenger == null && entity.vehicle == null) {
             entity.startRiding(this);
         }
         final double diffX = entity.x - this.x;
@@ -694,15 +721,13 @@ public class EntityMinecart extends Entity implements Container {
                     this.push(entity.xd - xForce, 0.0, entity.zd - zForce);
                     entity.xd *= 0.7;
                     entity.zd *= 0.7;
-                }
-                else if (otherType != FURNACE_CART && thisType == FURNACE_CART) {
+                } else if (otherType != FURNACE_CART && thisType == FURNACE_CART) {
                     entity.xd *= 0.2;
                     entity.zd *= 0.2;
                     entity.push(this.xd + xForce, 0.0, this.zd + zForce);
                     this.xd *= 0.7;
                     this.zd *= 0.7;
-                }
-                else {
+                } else {
                     final double avgXD = (entity.xd + this.xd) / 2.0;
                     final double avgZD = (entity.zd + this.zd) / 2.0;
                     this.xd *= 0.2;
@@ -712,8 +737,7 @@ public class EntityMinecart extends Entity implements Container {
                     entity.zd *= 0.2;
                     entity.push(avgXD + xForce, 0.0, avgZD + zForce);
                 }
-            }
-            else {
+            } else {
                 this.push(-xForce, 0.0, -zForce);
                 entity.push(xForce / 4.0, 0.0, zForce / 4.0);
             }
@@ -722,20 +746,18 @@ public class EntityMinecart extends Entity implements Container {
 
     @Override
     public boolean stillValid(Player player) {
-        if(isRemoved()) {
+        if (isRemoved()) {
             return false;
         }
         return player.distanceToSqr(this) <= 64D; // Can interact within 8 blocks
     }
 
     @Override
-	public boolean interact(@NotNull Player player) {
-        switch (getType()){
+    public boolean interact(@NotNull Player player) {
+        switch (getType()) {
             case PASSENGER_CART:
-                if (!world.isClientSide && passenger == null && player.isSneaking() && player.getHeldObject() instanceof CarriedBlock) {
-                    CarriedBlock carriedBlock = (CarriedBlock) player.getHeldObject();
-                    if (carriedBlock.entity instanceof TileEntityChest) {
-                        TileEntityChest chest = (TileEntityChest) carriedBlock.entity;
+                if (!this.world.isClientSide && this.passenger == null && player.isSneaking() && player.getHeldObject() instanceof CarriedBlock carriedBlock) {
+                    if (carriedBlock.entity instanceof TileEntityChest chest) {
                         setType(CHEST_CART);
                         if (carriedBlock.blockId == Blocks.CHEST_PLANKS_OAK_PAINTED.id()) {
                             setMeta(carriedBlock.metadata & TYPE_MASK_COLOR | TYPE_MASK_PAINTED_CHEST);
@@ -750,15 +772,15 @@ public class EntityMinecart extends Entity implements Container {
                         return true;
                     }
                 }
-                if(passenger != null && (passenger instanceof Player) && passenger != player) {
+                if (this.passenger != null && (this.passenger instanceof Player) && this.passenger != player) {
                     return true;
                 }
-                if(!world.isClientSide) {
+                if (!this.world.isClientSide) {
                     player.startRiding(this);
                 }
                 break;
             case CHEST_CART:
-                if(!world.isClientSide) {
+                if (!this.world.isClientSide) {
                     if (player.isSneaking() && player.inventory.getCurrentItem() == null && player.getHeldObject() == null) {
                         TileEntityChest tileEntityChest = new TileEntityChest();
                         for (int i = 0; i < this.getContainerSize(); i++) {
@@ -772,7 +794,7 @@ public class EntityMinecart extends Entity implements Container {
                         } else {
                             block = Blocks.CHEST_PLANKS_OAK;
                         }
-                        tileEntityChest.carriedBlock = tileEntityChest.getCarriedEntry(world, player, block, getMeta() & TYPE_MASK_COLOR);
+                        tileEntityChest.carriedBlock = tileEntityChest.getCarriedEntry(this.world, player, block, getMeta() & TYPE_MASK_COLOR);
                         player.setHeldObject(tileEntityChest.carriedBlock);
                         setType(PASSENGER_CART);
                         setMeta(0);
@@ -783,15 +805,14 @@ public class EntityMinecart extends Entity implements Container {
                 break;
             case FURNACE_CART:
                 ItemStack itemstack = player.inventory.getCurrentItem();
-                if(itemstack != null && LookupFuelFurnace.instance.getFuelYield(itemstack.itemID) > 0 && itemstack.consumeItem(player)) {
-                    if(itemstack.stackSize <= 0)
-                    {
+                if (itemstack != null && LookupFuelFurnace.instance.getFuelYield(itemstack.itemID) > 0 && itemstack.consumeItem(player)) {
+                    if (itemstack.stackSize <= 0) {
                         player.inventory.setItem(player.inventory.getCurrentItemIndex(), null);
                     }
-                    setFuel(getFuel() + MathHelper.round(((LookupFuelFurnace.instance.getFuelYield(itemstack.itemID)/1600F) * 1200)));
+                    setFuel(getFuel() + MathHelper.round(((LookupFuelFurnace.instance.getFuelYield(itemstack.itemID) / 1600F) * 1200)));
                 }
-                xPush = x - player.x;
-                zPush = z - player.z;
+                this.xPush = this.x - player.x;
+                this.zPush = this.z - player.z;
                 break;
         }
         return true;
@@ -801,22 +822,22 @@ public class EntityMinecart extends Entity implements Container {
     public void addAdditionalSaveData(@NotNull CompoundTag tag) {
         tag.putInt("Type", getType());
         tag.putInt("TypeMeta", getMeta());
-        switch (getType()){
+        switch (getType()) {
             case CHEST_CART:
                 ListTag nbttaglist = new ListTag();
-                for(int i = 0; i < items.length; i++) {
-                    if(items[i] != null) {
+                for (int i = 0; i < this.items.length; i++) {
+                    if (this.items[i] != null) {
                         CompoundTag nbttagcompound1 = new CompoundTag();
-                        nbttagcompound1.putByte("Slot", (byte)i);
-                        items[i].writeToNBT(nbttagcompound1);
+                        nbttagcompound1.putByte("Slot", (byte) i);
+                        this.items[i].writeToNBT(nbttagcompound1);
                         nbttaglist.addTag(nbttagcompound1);
                     }
                 }
                 tag.put("Items", nbttaglist);
                 break;
             case FURNACE_CART:
-                tag.putDouble("PushX", xPush);
-                tag.putDouble("PushZ", zPush);
+                tag.putDouble("PushX", this.xPush);
+                tag.putDouble("PushZ", this.zPush);
                 tag.putInt("Fuel", getFuel());
                 break;
         }
@@ -826,21 +847,21 @@ public class EntityMinecart extends Entity implements Container {
     public void readAdditionalSaveData(@NotNull CompoundTag tag) {
         setType((byte) tag.getInteger("Type"));
         setMeta(tag.getInteger("TypeMeta"));
-        switch (getType()){
+        switch (getType()) {
             case CHEST_CART:
                 ListTag nbttaglist = tag.getList("Items");
-                items = new ItemStack[getContainerSize()];
-                for(int i = 0; i < nbttaglist.tagCount(); i++) {
-                    CompoundTag nbttagcompound1 = (CompoundTag)nbttaglist.tagAt(i);
+                this.items = new ItemStack[getContainerSize()];
+                for (int i = 0; i < nbttaglist.tagCount(); i++) {
+                    CompoundTag nbttagcompound1 = (CompoundTag) nbttaglist.tagAt(i);
                     int j = nbttagcompound1.getByte("Slot") & 0xff;
-                    if(j < items.length) {
-                        items[j] = ItemStack.readItemStackFromNbt(nbttagcompound1);
+                    if (j < this.items.length) {
+                        this.items[j] = ItemStack.readItemStackFromNbt(nbttagcompound1);
                     }
                 }
                 break;
             case FURNACE_CART:
-                xPush = tag.getDouble("PushX");
-                zPush = tag.getDouble("PushZ");
+                this.xPush = tag.getDouble("PushX");
+                this.zPush = tag.getDouble("PushZ");
                 Tag<?> t = tag.getTag("Fuel");
                 if (t instanceof ShortTag) {
                     setFuel(((ShortTag) t).getValue());
@@ -868,20 +889,20 @@ public class EntityMinecart extends Entity implements Container {
 
     @Override
     public @Nullable ItemStack getItem(int index) {
-        return items[index];
+        return this.items[index];
     }
 
     @Override
     public @Nullable ItemStack removeItem(int index, int takeAmount) {
-        if(items[index] != null) {
-            if(items[index].stackSize <= takeAmount) {
-                ItemStack itemstack = items[index];
-                items[index] = null;
+        if (this.items[index] != null) {
+            if (this.items[index].stackSize <= takeAmount) {
+                ItemStack itemstack = this.items[index];
+                this.items[index] = null;
                 return itemstack;
             }
-            ItemStack itemstack1 = items[index].splitStack(takeAmount);
-            if(items[index].stackSize <= 0) {
-                items[index] = null;
+            ItemStack itemstack1 = this.items[index].splitStack(takeAmount);
+            if (this.items[index].stackSize <= 0) {
+                this.items[index] = null;
             }
             return itemstack1;
         } else {
@@ -891,8 +912,8 @@ public class EntityMinecart extends Entity implements Container {
 
     @Override
     public void setItem(int index, @Nullable ItemStack itemstack) {
-        items[index] = itemstack;
-        if(itemstack != null && itemstack.stackSize > getMaxStackSize()) {
+        this.items[index] = itemstack;
+        if (itemstack != null && itemstack.stackSize > getMaxStackSize()) {
             itemstack.stackSize = getMaxStackSize();
         }
     }
@@ -903,7 +924,7 @@ public class EntityMinecart extends Entity implements Container {
 
     @Override
     public void sortContainer() {
-        InventorySorter.sortInventory(items);
+        InventorySorter.sortInventory(this.items);
     }
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/enums/MobCategory.java b/game/core/src/main/java/net/minecraft/core/enums/MobCategory.java
index e655f22b3..74edf9686 100644
--- a/game/core/src/main/java/net/minecraft/core/enums/MobCategory.java
+++ b/game/core/src/main/java/net/minecraft/core/enums/MobCategory.java
@@ -1,46 +1,44 @@
 package net.minecraft.core.enums;
 
-import net.minecraft.core.entity.Entity;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.animal.AmbientCreature;
 import net.minecraft.core.entity.animal.Creature;
-import net.minecraft.core.entity.animal.MobAnimal;
-import net.minecraft.core.entity.animal.MobWaterAnimal;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.animal.WaterCreature;
 import net.minecraft.core.entity.monster.Enemy;
+import org.jetbrains.annotations.NotNull;
 
 public enum MobCategory {
-
-	monster("monster", 0, Enemy.class, 70, Material.air, false),
-    creature("creature", 1, Creature.class, 15, Material.air, true),
-    waterCreature("waterCreature", 2, WaterCreature.class, 5, Material.water, true),
-    ambientCreature("ambient", 3, AmbientCreature.class, 2, Material.air, true);
+	MONSTER(Enemy.class, 70, Materials.AIR, false),
+    CREATURE(Creature.class, 15, Materials.AIR, true),
+    WATER_CREATURE(WaterCreature.class, 5, Materials.WATER, true),
+    AMBIENT(AmbientCreature.class, 2, Materials.AIR, true);
 	
-	private final Class<?> baseClass;
+	private final @NotNull Class<?> baseClass;
 	private final int maxPerChunk;
 	private final Material spawnMaterial;
 	private final boolean isPeaceful;
 
-	MobCategory(String name, int id, Class<?> baseClass, int maxPerChunk, Material spawnMaterial, boolean isPeaceful) {
+	MobCategory(final @NotNull Class<?> baseClass, final int maxPerChunk, final @NotNull Material spawnMaterial, final boolean isPeaceful) {
 		this.baseClass = baseClass;
 		this.maxPerChunk = maxPerChunk;
 		this.spawnMaterial = spawnMaterial;
 		this.isPeaceful = isPeaceful;
 	}
 
-	public Class<?> getBaseClass() {
-		return baseClass;
+	public @NotNull Class<?> getBaseClass() {
+		return this.baseClass;
 	}
 
 	public int getMaxCreaturesPerChunk() {
-		return maxPerChunk;
+		return this.maxPerChunk;
 	}
 
-	public Material getSpawnMaterial() {
-		return spawnMaterial;
+	public @NotNull Material getSpawnMaterial() {
+		return this.spawnMaterial;
 	}
 
 	public boolean isPeaceful() {
-		return isPeaceful;
+		return this.isPeaceful;
 	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/IBonemealable.java b/game/core/src/main/java/net/minecraft/core/item/IBonemealable.java
index 5e43c1cb8..0f7cad7b7 100644
--- a/game/core/src/main/java/net/minecraft/core/item/IBonemealable.java
+++ b/game/core/src/main/java/net/minecraft/core/item/IBonemealable.java
@@ -4,11 +4,12 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public interface IBonemealable {
-    boolean onBonemealUsed(final @NotNull ItemStack itemStack, final @Nullable Player player, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit);
+    boolean onBonemealUsed(final @NotNull ItemStack itemStack, final @Nullable Player player, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit);
 
     @Deprecated
     default boolean onBonemealUsed(final @NotNull ItemStack itemStack, final @Nullable Player player, final @NotNull World world, final int x, final int y, final int z, final @NotNull Side side, final double xHit, final double yHit) {
diff --git a/game/core/src/main/java/net/minecraft/core/item/Item.java b/game/core/src/main/java/net/minecraft/core/item/Item.java
index 708db3305..13bc34eff 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Item.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Item.java
@@ -23,6 +23,7 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -224,7 +225,7 @@ public class Item implements ITaggable<Item>, IItemConvertible {
     public final boolean onUseItemOnBlock(@NotNull final ItemStack selfStack, @Nullable final Player player, @NotNull final World world, final int blockX, final int blockY, final int blockZ, @NotNull final Side side, final double xPlaced, final double yPlaced) {
         return onUseOnBlock(selfStack, world, player, new TilePos(blockX, blockY, blockZ), side, xPlaced, yPlaced);
     }
-    public boolean onUseOnBlock(final @NotNull ItemStack selfStack, final @NotNull World world, final @Nullable Player player, final @NotNull TilePos blockPos, final @NotNull Side side, final double xHit, final double yHit) {
+    public boolean onUseOnBlock(final @NotNull ItemStack selfStack, final @NotNull World world, final @Nullable Player player, final @NotNull TilePosc blockPos, final @NotNull Side side, final double xHit, final double yHit) {
         return false;
     }
 
@@ -232,7 +233,7 @@ public class Item implements ITaggable<Item>, IItemConvertible {
     public final void onUseByActivator(final @NotNull ItemStack selfStack, final @NotNull TileEntityActivator activator, final @NotNull World world, final @NotNull Random random, final int blockX, final int blockY, final int blockZ, final double offX, final double offY, final double offZ, final @NotNull Direction direction) {
         onUseByActivator(selfStack, world, activator, random, new TilePos(blockX, blockY, blockZ), direction, offX, offY, offZ);
     }
-    public void onUseByActivator(final @NotNull ItemStack selfStack, final @NotNull World world, final @NotNull TileEntityActivator activator, final @NotNull Random random, final @NotNull TilePos blockPos, final @NotNull Direction direction, final double offX, final double offY, final double offZ) {
+    public void onUseByActivator(final @NotNull ItemStack selfStack, final @NotNull World world, final @NotNull TileEntityActivator activator, final @NotNull Random random, final @NotNull TilePosc blockPos, final @NotNull Direction direction, final double offX, final double offY, final double offZ) {
 
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBed.java b/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
index eb55bd66a..341ec886f 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
@@ -7,27 +7,27 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class ItemBed extends Item {
 
-    public ItemBed(@NotNull String name, @NotNull String namespaceId, int id)
-    {
+    public ItemBed(@NotNull String name, @NotNull String namespaceId, int id) {
         super(name, namespaceId, id);
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
-        TilePos pos = blockPos;
-        if(!world.canPlaceInsideBlock(pos)) {
-            pos = pos.add(side.getDirection());
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
+        TilePosc pos = blockPos;
+        if (!world.canPlaceInsideBlock(pos)) {
+            pos = pos.add(side.getDirection(), new TilePos());
         }
         Direction dir = player == null ? Direction.NORTH : player.getHorizontalPlacementDirection(null).getOpposite();
-        TilePos pos2 = pos.add(dir);
-        if(world.isAirBlock(pos) && world.isAirBlock(pos2) && world.canPlaceOnSurfaceOfBlock(pos.down()) && world.canPlaceOnSurfaceOfBlock(pos2.down())) {
-            if(world.canBlockIdBePlacedAt(Blocks.BED.id(), pos, false, side) && selfStack.consumeItem(player)) {
-                world.playBlockSoundEffect(player, pos.x + 0.5F, pos.y + 0.5F, pos.z + 0.5F, Blocks.BED, EnumBlockSoundEffectType.PLACE);
+        TilePos pos2 = pos.add(dir, new TilePos());
+        if (world.isAirBlock(pos) && world.isAirBlock(pos2) && world.canPlaceOnSurfaceOfBlock(pos.down(new TilePos())) && world.canPlaceOnSurfaceOfBlock(pos2.down(new TilePos()))) {
+            if (world.canBlockIdBePlacedAt(Blocks.BED.id(), pos, false, side) && selfStack.consumeItem(player)) {
+                world.playBlockSoundEffect(player, pos.x() + 0.5F, pos.y() + 0.5F, pos.z() + 0.5F, Blocks.BED, EnumBlockSoundEffectType.PLACE);
                 world.setBlockIdDataNotify(pos, Blocks.BED.id(), dir.getHorizontalIndex());
                 world.setBlockIdDataNotify(pos2, Blocks.BED.id(), dir.getHorizontalIndex() | 0b1000);
                 return true;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java b/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java
index 00501561b..05c89c8c3 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java
@@ -8,6 +8,7 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -23,13 +24,13 @@ public class ItemBoat extends Item {
     @Override
     public @Nullable ItemStack onUse(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Player player) {
         HitResult rayCast = player.rayCast(player.getGamemode().getBlockReachDistance(), 1f, true, false, false);
-        if(rayCast == null) {
+        if (rayCast == null) {
             return selfStack;
         }
-        if(rayCast instanceof HitResult.Tile hitTile) {
+        if (rayCast instanceof HitResult.Tile hitTile) {
             TilePos pos = new TilePos(hitTile.tilePos);
-            if(!world.isClientSide) {
-                if(world.getBlockId(pos) == Blocks.LAYER_SNOW.id()) {
+            if (!world.isClientSide) {
+                if (world.getBlockId(pos) == Blocks.LAYER_SNOW.id()) {
                     pos.y--;
                 }
                 EntityBoat boat = new EntityBoat(world, pos.x + 0.5F, pos.y + 1.0F, pos.z + 0.5F);
@@ -42,10 +43,10 @@ public class ItemBoat extends Item {
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        double x = blockPos.x + offX + direction.getOffsetX();
-        double y = blockPos.y + offY + direction.getOffsetY();
-        double z = blockPos.z + offZ + direction.getOffsetZ();
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        double x = blockPos.x() + offX + direction.getOffsetX();
+        double y = blockPos.y() + offY + direction.getOffsetY();
+        double z = blockPos.z() + offZ + direction.getOffsetZ();
         selfStack.consumeItem(null);
         EntityBoat boat = new EntityBoat(world, x, y, z);
         world.entityJoinedWorld(boat);
